<template>
	<el-row class="receiveable">
		<!-- <el-row style="display:flex;justify-content:flex-end;">
			<el-button
				type="primary"
				size="small"
				plain
				:disabled="disableDialog"
				@click="dialogFormVisible = true"
			>新增应收账款</el-button>
		</el-row> -->
		<ootecoTable
			class="marginTop20"
			ref="receiveableTable"
			:conf="tableConf"
			:url="$route.query.businessId ? 'biz/ac/select/list?businessId=' + $route.query.businessId : ''"
		></ootecoTable>
		<el-dialog title="新增应收账款" center :visible.sync="dialogFormVisible">
			<el-form :model="form" label-width="5rem">
				<el-row>
					<el-col :span="16" :offset="4">
						<el-form-item label="到期日期">
							<el-date-picker
								v-model="form.endTime"
								value-format="yyyyMMdd"
								type="date"
								placeholder="选择日期"
							></el-date-picker>
						</el-form-item>
					</el-col>
				</el-row>
				<el-row>
					<el-col :span="16" :offset="4">
						<el-form-item label="金额">
							<el-input
								style="width:220px;"
								type="number"
								v-model="form.amount"
								autocomplete="off"
								placeholder="请输入金额"
							></el-input>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button @click="dialogFormVisible = false">取 消</el-button>
				<el-button type="primary" @click="confirmAdd">确 定</el-button>
			</div>
		</el-dialog>
		<el-dialog title="上传资料" center :visible.sync="dialogDataVisible">
			<el-form :model="form" label-width="5rem">
				<el-row>
					<el-col :span="16" :offset="4">
						<el-form-item label="附件类型">
							<el-select v-model="value" placeholder="请选择">
								<el-option
									v-for="item in options"
									:key="item.value"
									:label="item.label"
									:value="item.value"
								></el-option>
							</el-select>
						</el-form-item>
					</el-col>
				</el-row>
				<el-row>
					<el-col :span="20" :offset="4">
						<el-form-item label="附件资料">
							<el-row style="height:2.5rem;" class="flexVcenter">
								<ootecoUpload :conf="extraFile"></ootecoUpload>
							</el-row>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button @click="dialogDataVisible = false">取 消</el-button>
				<el-button type="primary" @click="confirmAddFile">确 定</el-button>
			</div>
		</el-dialog>
		<el-dialog title="发票信息" center :visible.sync="dialogInvoiceVisible" width="80%">
			<ooteco-table :conf="invoiceTableConf"></ooteco-table>
		</el-dialog>
		<el-dialog :title="dialogTitle" center :visible.sync="dialogDatasVisible" width="60%">
			<ooteco-table :conf="datasTableConf"></ooteco-table>
		</el-dialog>
	</el-row>
</template>

<script>
import ootecoTable from '@com/ooteco_table'
import ootecoUpload from '@com/ooteco_upload'
import accountReceivable from '../data_conf/accountReceiveable.js'
export default {
	mixins: [$mixin],
	components: { ootecoTable, ootecoUpload },
	data() {
		return Object.assign({}, utils.deepClone(accountReceivable), {
			disableDialog: false,
			dialogDatasVisible: false,
			dialogInvoiceVisible: false,
			dialogFormVisible: false,
			dialogDataVisible: false,
			dialogData: '',
			dialogTitle: '',
			currentInvoice: {},
			value: '',
			invoiceRowData: '',
			extraFile: {
				class: 2,
				type: 'button',
				multifile: true
			},
			createInfo: {},
			form: {
				endTime: '',
				amount: '',
				financingAmount: '0',
				acceptAmount: '0'
			},
			tableConf: {
				params: {
					pageSize: 100
				},
				otherColumn: {
					index: {}
				},
				data: [],
				headers: [
					{
						label: '到期日',
						prop: 'endTime',
						width: 100,
						filter: val => {
							return val.substr(0, 10)
						}
					},
					{
						label: '融资金额(元)',
						prop: 'financingAmount',
						width: 80
					},
					{
						label: '金额(元)',
						prop: 'amount',
						width: 80
					},
					{
						label: '受理金额(元)',
						prop: 'acceptAmount',
						width: 80
					},
					{
						label: '发票',
						prop: 'invoiceDetail',
						type: 'textButton',
						width: 100,
						buttons: [
							{
								type: 'upload',
								sub_conf: {
									url: 'tripartite/requestOcr',
									data: { apiType: 1, type: 3 },
									flag: 'invoice',
									type: 'text',
									text: '新增'
								}
							},
							{
								text: '明细',
								event: data => {
									if (!data.row.invoiceDetail) {
										this.alert('请先新增发票')
										return false
									}
									this.invoiceRowData = data
									this.dialogInvoiceVisible = true
									this.$set(
										this.invoiceTableConf,
										'data',
										data.row.invoiceDetail.invoices
									)
								}
							}
						]
					},
					{
						label: '证明资料',
						prop: 'attachments',
						type: 'textButton',
						buttons: [
							{
								text: '上传',
								event: data => {
									this.dialogData = data
									this.value = ''
									this.extraFile = {
										class: 2,
										type: 'button',
										multifile: true
									}
									this.dialogDataVisible = true
								}
							}
						]
					},
					{
						label: '状态',
						type: 'textOrButton',
						width: 100,
						prop: 'checkStatusName',
						buttons: [
							{
								text: '提交审核',
								event: data => {
									let formData = this.createFormData(data.row)
									this.$http
										.post({
											url: 'biz/ac/add',
											params: formData
										})
										.then(
											data => {
												this.alert('新增成功', () => {
													this.$refs.receiveableTable.requestData()
												})
											},
											msg => {
												this.alert(msg)
											}
										)
								}
							}
						]
					},{
						label :'中登网登记'
						//TODO
					},{
						label : '操作',
						//TODO
					}
				]
			}
		})
	},
	created() {
		this.$set(this.tableConf, 'params', {
			businessId: this.$route.query.businessId,
			pageSize: 100
		})
	},
	methods: {
		returnFromData() {
			if (!this.tableConf.data.length) {
				this.alert('请先新增应收账款')
				return false
			}
			return this.createFormData(this.tableConf.data[0])
		},
		createFormData(data) {
			if (!data.invoiceDetail) {
				this.alert('请上传发票图片')
				return false
			}
			// if (!data.attachments) {
			// 	this.alert('请上传证明资料')
			// 	return false
			// }
			let formData = new FormData()
			formData.append('endTime', data.endTime)
			formData.append('amount', data.amount)
			formData.append(
				'invoiceJson',
				JSON.stringify(data.invoiceDetail.invoices)
			)
			this.$route.query.businessId &&
				formData.append('businessId', this.$route.query.businessId)
			for (const key in data.attachments) {
				for (const item of data.attachments[key]) {
					formData.append(key, item.file)
				}
			}
			for (const item of data.invoiceFiles) {
				formData.append('invoices', item.raw)
			}
			return formData
		},
		confirmAdd() {
			if (!this.form.endTime || !this.form.amount) {
				this.alert('请先完善信息')
				return false
			}
			let arr = utils.deepClone(this.tableConf.data)
			arr.push(utils.deepClone(this.form))
			this.$set(this.tableConf, 'data', arr)
			this.$nextTick(() => {
				this.form.endTime = ''
				this.form.amount = ''
				this.dialogFormVisible = false
				this.disableDialog = true
			})
		},
		confirmAddFile() {
			if (!this.value || (!this.extraFile.files && !this.extraFile.file)) {
				this.alert('请完善信息')
				return false
			}
			if (!this.dialogData.row.attachments) {
				this.$set(this.dialogData.row, 'attachments', {})
			}
			let arr = this.dialogData.row.attachments[this.value] || []
			if (this.extraFile.files) {
				let new_arr = this.extraFile.files.map(item => {
					return {
						file: item,
						attachName: item.name
					}
				})
				arr = [...arr, ...new_arr]
			} else {
				arr.push({
					file: this.extraFile.file,
					attachName: this.extraFile.file.name
				})
			}
			this.$set(this.dialogData.row.attachments, this.value, arr)
			this.dialogDataVisible = false
		},
		confirmAddInvoice() {},
		initListen() {
			this.listen('uploadSuccess', ({ res, conf, file }) => {
			    this.currentInvoice = res.data;
				this.$http
					.post({
						url: 'tripartite/requestVerify',
						params: {
							apiType: 2,
							type: 3,
							fpdm: res.data.code,
							fphm: res.data.number,
							je: res.data.totalPriceAmount,
							jym: res.data.checkCode,
							kprq: res.data.invoiceDate
								.split(' ')[0]
								.split('-')
								.join('')
						}
					})
					.then(
						({data}) => {
							if (JSON.parse(data).status !== '001') {
								this.alert('发票验证不通过')
								this.$set(this.currentInvoice, 'checkPass', false);
							}else{
							    this.$set(this.currentInvoice, 'checkPass', true);
							}
						},
						msg => {
							this.alert(msg)
						}
					)
				if (!conf.row.invoiceDetail) {
					conf.row['invoiceDetail'] = {
						invoices: []
					}
				}
				console.log(this.currentInvoice);
				if (!conf.row.invoiceFiles) {
					conf.row['invoiceFiles'] = []
				}
				let files = conf.row.invoiceFiles
				files.push(file)
				let arr = conf.row.invoiceDetail.invoices || []
				arr.push(this.currentInvoice)
				this.$set(conf.row.invoiceDetail, 'invoices', arr)
				this.$set(conf.row, 'invoiceFiles', files)
			})
			this.listen('fileChange', ({ conf }) => {
				console.log(conf)
			})
			this.listen('showDatasDialogAction', ({ title, val, scope }) => {
				this.datasTableConf.headers[
					this.datasTableConf.headers.length - 1
				].show = scope.checkStatus !== 2
				this.$nextTick(() => {
					this.dialogDatasVisible = true
					this.dialogTitle = title
					this.$set(this.datasTableConf, 'data', val)
				})
			})
			this.listen('handleSelectionChange', val => {
				this.$set(this.invoiceRowData.row, 'rowSelect', val)
			})
		}
	},
	mounted() {
		this.initListen()
	}
}
</script>

<style lang="less">
div.receiveable {
	.dialog-footer {
		text-align: center;
		button:nth-child(1) {
			margin-right: 2.5rem;
		}
	}
	td {
		.cell {
			div {
				text-align: center;
			}
		}
	}
}
</style>
